variables:
  GITLAB_CI_IMAGE_ALPINE: 'alpine:3.16.2'
  GITLAB_CI_IMAGE_DOCKER: 'docker:20.10.18'
  GITLAB_CI_IMAGE_BINFMT: 'tonistiigi/binfmt:qemu-v7.0.0-28'
  GITLAB_CI_DOCKER_BUILDX_PLATFORMS: 'linux/amd64,linux/arm/v7,linux/arm64'
  GITLAB_CI_SIGN_OFF_EXCLUDE: '32becff6dbf29cdc76145683f6696d670def1837'
stages:
  - static
  - test
  - deploy
  - security

# 'static' stage
sign_off:
  stage: static
  needs: []
  image: ${GITLAB_CI_IMAGE_ALPINE}
  before_script:
    - apk add --no-cache git
  script: >-
    git log
    --grep "^Signed-off-by: .\+<.\+\(@\| at \).\+\(\.\| dot \).\+>$"
    --invert-grep
    --format="Detected commit '%h' with missing or bad sign-off! Please read 'CONTRIBUTING.md'."
    --exit-code
    $(rev=$(git rev-parse -q --verify "$GITLAB_CI_SIGN_OFF_EXCLUDE^{commit}") && echo "$rev..")

# 'deploy' stage
deploy:
  stage: deploy
  needs: []
  image: ${GITLAB_CI_IMAGE_DOCKER}
  services:
    - ${GITLAB_CI_IMAGE_DOCKER}-dind
  before_script:
    - docker run --privileged --rm ${GITLAB_CI_IMAGE_BINFMT} --uninstall qemu-*
    - docker run --privileged --rm ${GITLAB_CI_IMAGE_BINFMT} --install all
  script:
    - >-
      docker buildx
      create
      --use
      --name container
      --driver docker-container
      --bootstrap
    - 'CACHE_IMAGE="${CI_REGISTRY_IMAGE:+$CI_REGISTRY_IMAGE/qubik-listener:${CI_COMMIT_REF_NAME}}"; export CACHE_IMAGE'
    - '[ -z "$CI_REGISTRY_IMAGE" ] || docker login -u $CI_REGISTRY_USER -p $CI_JOB_TOKEN $CI_REGISTRY'
    - >-
      docker buildx
      bake
      --progress plain
      -f docker-compose.yml
      ${CI_REGISTRY_IMAGE:+ -f docker-compose.cache.yml}
      --pull
      --set "*.platform=${GITLAB_CI_DOCKER_BUILDX_PLATFORMS}"
      ${CI_REGISTRY_IMAGE:+ --set "*.tags=$CI_REGISTRY_IMAGE/qubik-listener:${CI_COMMIT_REF_NAME}"}
      ${CI_REGISTRY_IMAGE:+ --set "*.tags=$CI_REGISTRY_IMAGE/qubik-listener:latest"}
      ${CI_REGISTRY_IMAGE:+ --push}
      qubik_listener
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH

# 'security' stage
include:
  - template: Security/Container-Scanning.gitlab-ci.yml
container_scanning:
  stage: security
  needs:
    - job: deploy
      artifacts: false
  variables:
    CI_APPLICATION_REPOSITORY: ${CI_REGISTRY_IMAGE}/qubik-listener
    CI_APPLICATION_TAG: latest
  rules:
    - if: $CI_REGISTRY_IMAGE && $CI_COMMIT_BRANCH == "main"
